/*

SAS[U[2012

Տɂᇏkʂ̌ɗLpȃOt̍쐬
-SGPLOTvVW̍ŐV@\p-

Drawing the useful graphs for the tumor shrinkage
assessment in cancer clinical trials
-Innovative uses of new features in PROC SGPLOT- 

Program : Uozumi_SASUSER2012.sas
Made by : Ryuji Uozumi
Date : 2012/07/10

SAS Version : 9.3

*/

*======================================================================*;
* tH[}bg ;
*======================================================================*;

proc format;
  value RECISTf 1='Complete response by RECIST'
                2='Partial response by RECIST'
                3='Stable disease by RECIST'
                4='Progressive disease by RECIST'
				11='CR+PR'
				12='SD'
				13='PD'
  ;
  value Subgroupf 1='Subgroup 1'
                  2='Subgroup 2'
                  3='Subgroup 3'
                  4='Subgroup 4'
  ;
  value WaterfallChartf 1="̗v"
                        2="ޗ̍팸"
						3="A̍팸"
						4="YČ"
						5="Mbv"
  ;
  value Responsef 1="CR+PR"
  ;
run;

*======================================================================*;
* WaterfallvbgpTvf[^ ;
*======================================================================*;

data waterfall;
input id TumorChange RECIST Subgroup;
datalines;
1	-25.49 	3	1
2	-6.89 	3	1
3	-33.68 	2	1
4	-43.87 	2	1
5	17.68 	3	1
6	-69.63 	2	1
7	-11.16 	3	1
8	-44.05 	2	1
9	69.45 	4	1
10	66.97 	4	1
11	-38.06 	3	1
12	12.67 	4	1
13	-53.60 	2	1
14	-50.30 	3	1
15	16.43 	4	1
16	-58.62 	2	2
17	-50.36 	2	2
18	-13.88 	3	2
19	-11.52 	3	2
20	-100.00 	1	2
21	-1.79 	3	2
22	6.80 	3	2
23	-60.30 	2	2
24	-100.00 	1	2
25	-30.57 	2	2
26	0.39 	3	2
27	-59.82 	2	2
28	-81.69 	2	2
29	-29.48 	3	2
30	-50.43 	2	2
31	51.37 	4	2
32	-86.18 	2	3
33	91.14 	4	3
34	-72.24 	2	3
35	40.72 	4	3
36	-77.27 	2	3
37	-14.45 	3	3
38	-59.64 	2	3
39	-5.56 	3	3
40	-32.90 	2	3
41	-70.43 	2	3
42	-20.66 	3	3
43	-100.00 	1	3
44	33.70 	4	3
45	-53.52 	2	3
46	-33.25 	2	3
47	-59.79 	2	3
48	25.16 	4	3
49	-100.00 	1	4
50	76.53 	4	4
51	23.26 	4	4
52	-19.25 	3	4
53	-6.38 	3	4
54	-29.52 	3	4
55	52.28 	4	4
56	-81.25 	2	4
57	24.53 	4	4
58	-58.55 	2	4
59	-49.30 	2	4
60	12.98 	3	4
61	30.57 	4	4
62	-100.00 	1	4
63	-96.71 	2	4
64	38.58 	4	4
65	-2.40 	3	4
;
run;

*======================================================================*;
* t̃vbg쐬̂߂̃f[^HE ;
*======================================================================*;

data ResponseRate00;set waterfall;
  if RECIST in(1,2) then response=1;
  else response=0;
run;

proc sort data=ResponseRate00 out=ResponseRate00;
  by descending response;
run;

ods listing close;
ods output BinomialProp=ResponseRate01 BinomialCLs=ResponseRate02;
proc freq data=ResponseRate00 order=data;
  tables response / binomial(clopperpearson);
run;
ods listing;

data ResponseRate;
  merge ResponseRate01(where=(Name1="_BIN_"))
        ResponseRate02
  ;
  keep ResponseRate Lower Upper Type Group;
  ResponseRate=nValue1*100;
  Lower=LowerCL*100;
  Upper=UpperCL*100;
  Group=1;
run;

*======================================================================*;
* t̃vbg ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=ResponseRate;
  vbarparm category=Group response=ResponseRate / limitlower=Lower
                                                 limitupper=Upper
											     limitattrs=(thickness=3px color=black)
                                                 barwidth=0.50
                                                 transparency=0.1
  ;
  xaxis display=(nolabel noticks);
  yaxis label='Response Rate (%)'
        values=(0 to 100 by 10)
  ;
  format Group Responsef.;
run;
ods graphics off;
ods html close;

*======================================================================*;
* Waterfallvbgɂxf[^𐶐 ;
*======================================================================*;

proc sort data=waterfall out=waterfall;
  by descending TumorChange;
run;

data waterfall;set waterfall;
  retain order 0;
  order=order+1;
  format RECIST RECISTf.
         Subgroup Subgroupf.
  ;
run;

*======================================================================*;
* Waterfallvbg ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;

proc sgplot data=waterfall noautolegend;
  vbar order / response=TumorChange
               group=RECIST
  ;
run;

proc sgplot data=waterfall noautolegend;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  xaxis display=(novalues nolabel noticks);
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;

ods graphics off;
ods html close;

*======================================================================*;
* x[XC̏k0%̔팱Ґ () Zo ;
*======================================================================*;

ods listing close;
ods output summary=nTotal;
proc means data=waterfall n;
  var id;
run;
ods listing;

data _null_;set nTotal;
  call symputx("nTotal",put(id_N,best.));
run;

ods listing close;
ods output summary=n0;
proc means data=waterfall(where=(TumorChange<0)) n;
  var id;
run;
ods listing;

data _null_;set n0;
  call symputx("n0",put(id_N,best.));
  call symputx("prop0",put(round(id_N/&nTotal*100,1e-1),4.1));
run;

ods listing close;
ods output summary=ArrowMin;
proc means data=waterfall(where=(TumorChange<=0)) min;
  var order;
run;
ods listing;

data _null_;set ArrowMin;
  call symputx("ArrowMin",put(order_Min,best.));
run;

ods listing close;
ods output summary=ArrowMax;
proc means data=waterfall(where=(TumorChange<=0)) max;
  var order;
run;
ods listing;

data _null_;set ArrowMax;
  call symputx("ArrowMax",put(order_Max,best.));
run;

*======================================================================*;
* ANNOTATE step1 :  ;
*======================================================================*;

data annotate1;
  function="arrow";
  direction="both";
  x1space="WALLPERCENT"; x2space="WALLPERCENT";
  y1space="WALLPERCENT"; y2space="WALLPERCENT";
  x1=&ArrowMin/&ArrowMax*100;
  y1=50+1+1/2;
  x2=(&ArrowMax-1/2)/&ArrowMax*100;
  y2=50+1+1/2;
  linecolor="black";
  scale=0.5;
  output;
run;

*======================================================================*;
* ANNOTATEɂWaterfallvbg ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=waterfall sganno=annotate1 noautolegend;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  xaxis display=(novalues nolabel noticks);
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;
ods graphics off;
ods html close;

*======================================================================*;
* ANNOTATE step2 :  ;
*======================================================================*;

data annotate2;
  function="text";
  x1space="WALLPERCENT";
  y1space="WALLPERCENT";
  x1=((&ArrowMin+&ArrowMax)/2)/&ArrowMax*100;
  y1=50+1+1/2+1/2;
  width=100;
  anchor="bottom";
  output;
  function = "textcont";
  label="N = &n0. / &nTotal. (&prop0.%)";
  textsize=15;
  output;
run;

*======================================================================*;
* ANNOTATEɂeLXgWaterfallvbg ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=waterfall sganno=annotate2 noautolegend;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  xaxis display=(novalues nolabel noticks);
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;
ods graphics off;
ods html close;

*======================================================================*;
* ANNOTATE step3 : L ;
*======================================================================*;

data annotate3;set waterfall;
  if TumorChange<-30 then do;
    if RECIST=3 then ast=1;
  end;
  if TumorChange<20 then do;
    if RECIST=4 then ast=1;
  end;
run;

data annotate3;set annotate3;where ast=1;
  length anchor $ 6;
  function="text"; justify="center";
  x1space="datavalue"; x1=order; y1space="datavalue"; y1=TumorChange;
  x1=order;
  if TumorChange<0 then do;
    y1=TumorChange+3;
    anchor="top";
  end;
  else if 0<=TumorChange then do;
    y1=TumorChange-3;
    anchor="bottom";
  end;
  label="*";
  output;
run;

*======================================================================*;
* ANNOTATEɂLWaterfallvbg ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=waterfall sganno=annotate3 noautolegend;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  xaxis display=(novalues nolabel noticks);
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  refline -30 20 / axis=y lineattrs=(pattern=dash);
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;
ods graphics off;
ods html close;

*======================================================================*;
* SGANNOAvVɂAWWaterfallvbg ;
*======================================================================*;

data anno;
  set annotate1 annotate2 annotate3;
run;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=waterfall noautolegend sganno=anno;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  xaxis display=(novalues nolabel noticks);
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  refline -30 20 / axis=y lineattrs=(pattern=dash);
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
/*  footnote1 j=right "Asterisk indicates patients with new lesions";*/
/*  footnote2 j=l " ";*/
run;
ods graphics off;
ods html close;

*======================================================================*;
* SGPLOTvVWŏdˍ킹邱ƂłȂXe[gg̑gݍ킹 ;
*======================================================================*;
/*
data waterfall00;set waterfall;
  xmin=&ArrowMin;
  xmax=&ArrowMax;
  ymin=0.5;
  ymax=0.5;
run;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=waterfall00;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  vector x=xmax y=ymax / arrowdirection=both
                         xorigin=xmin yorigin=ymin
					     lineattrs=(thickness=3px pattern=solid color=black)
  ;
  xaxis display=(novalues nolabel noticks)
        values=(0 to &ArrowMax by 1)
  ;
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;
proc sgplot data=waterfall00;
  vbar order / response=TumorChange barwidth=0.95
               transparency=0.5
               group=RECIST
			   grouporder=ascending
			   name='RECIST'
  ;
  highlow high=xmax low=xmin y=ymax / type=line
									  highcap=barbedarrow
									  lowcap=barbedarrow
									  lineattrs=(color=black thickness=3px)
  ;
  xaxis display=(novalues nolabel noticks)
        values=(0 to &ArrowMax by 1)
  ;
  yaxis label='Change from Baseline (%)'
        values=(-100 to 100 by 20)
  ;
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;
ods graphics off;
ods html close;
*/
*======================================================================*;
* SGPLOTvVWɂWATERFALLXe[gg̗p ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=waterfall;
  waterfall category=order response=TumorChange
            / barwidth=0.95
              transparency=0.5
              colorgroup=RECIST
			  name='RECIST'
  ;
  xaxis display=(novalues nolabel noticks);
  yaxis label='Change from Baseline(%)'
/*        values=(-100 to 100 by 20)*/
  ;
  keylegend 'RECIST' / title=''
                       position=topright
					   location=inside
					   down=4
					   noborder
  ;
run;
ods graphics off;
ods html close;

*======================================================================*;
* Waterfall`[g쐬pTvf[^ ;
*======================================================================*;

data WaterfallChart;
input x y z;
format x WaterfallChartf.;
datalines;
1 52 0
2 8 1
3 10 1
4 20 1
5 10 2
;
run;

*======================================================================*;
* Waterfall`[g ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=500px height=400px
               imagefmt=png
;
proc sgplot data=WaterfallChart noautolegend;
  waterfall category=x response=y
            / barwidth=0.8
			  finalbartickvalue="vڕW"
              colorgroup=z
			  datalabel
			  datalabelattrs=(color=black size=20)
  ;
  xaxis display=(nolabel noticks);
  yaxis display=(novalues nolabel noticks) min=-10 max=110;
  inset "P : S~" / position=topleft noborder;
run;
ods graphics off;
ods html close;

*======================================================================*;
* ̃Cxg܂ł̊Ԃ̃vbgpTvf[^ ;
*======================================================================*;

data TimeToEvent;
input id TTP TTR censor_OS censor_TTP;
OS=TTP;
datalines;
1	8.10 	1.03 	0	1
2	7.00 	4.00 	0	1
3	9.80 	1.00 	0	0
4	9.80 	0.99 	0	1
5	4.30 	1.00 	0	1
6	15.50 	0.99 	0	0
7	7.00 	0.98 	0	1
8	9.80 	9.00 	0	1
9	3.50 	2.00 	0	0
10	3.70 	0.95 	0	0
11	9.80 	0.98 	0	0
12	5.80 	3.00 	0	1
13	12.70 	7.00 	0	1
14	11.80 	9.00 	1	1
15	5.00 	1.02 	0	1
16	13.00 	1.01 	1	1
17	12.00 	4.00 	0	1
18	7.00 	1.01 	0	1
19	7.00 	1.00 	0	0
20	19.80 	1.00 	0	0
21	6.30 	1.00 	0	1
22	5.90 	4.00 	0	1
23	15.00 	8.00 	0	0
24	19.50 	8.00 	0	0
25	8.50 	0.98 	0	1
26	6.00 	0.99 	1	1
27	15.00 	12.00 	0	0
28	17.00 	6.00 	0	0
29	8.10 	3.00 	0	0
30	12.70 	1.02 	0	1
31	4.00 	1.02 	0	1
32	17.00 	1.01 	0	0
33	2.80 	1.01 	0	1
34	15.50 	9.00 	0	0
35	4.00 	2.00 	0	1
36	16.00 	8.00 	0	0
37	7.00 	3.00 	0	1
38	13.00 	0.99 	0	1
39	6.80 	1.03 	0	1
40	9.00 	1.04 	0	0
41	15.50 	1.02 	0	0
42	8.00 	0.98 	0	1
43	18.00 	1.00 	1	1
44	4.00 	1.02 	0	0
45	12.70 	4.00 	0	0
46	9.60 	0.99 	1	1
47	14.00 	0.99 	0	0
48	4.00 	1.04 	0	1
49	18.00 	0.99 	1	1
50	3.00 	1.03 	0	1
51	4.30 	2.10 	0	1
52	7.00 	1.01 	0	1
53	7.00 	3.00 	0	1
54	8.50 	4.00 	0	1
55	3.80 	1.03 	0	1
56	17.00 	1.04 	0	0
57	4.00 	1.00 	0	1
58	13.00 	1.01 	0	0
59	10.00 	3.00 	0	0
60	5.70 	1.05 	0	1
61	4.00 	0.98 	0	1
62	17.80 	1.02 	0	0
63	17.50 	0.98 	0	0
64	4.00 	0.99 	0	1
65	6.50 	0.99 	0	1
;
run;

*======================================================================*;
* ̃Cxg܂ł̊Ԃ̃vbg쐬̂߂̃f[^H ;
*======================================================================*;

proc sort data=TimeToEvent out=TimeToEvent00;
  by TTP;
run;

data TimeToEvent00;set TimeToEvent00;
  retain order 0;
  order=order+1;
run;

data TimeToEvent00;set TimeToEvent00;
  if censor_OS=1 then OS0=OS;
  else if censor_TTP=0 then TTP0=TTP;
run;

*======================================================================*;
* ̃Cxg܂ł̊Ԃ̃vbg ;
*======================================================================*;

ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=TimeToEvent00 noautolegend nocycleattrs;
  vector x=TTP y=order / noarrowheads
                         yorigin=order
					     lineattrs=(thickness=3px pattern=solid color=yellow)
						 legendlabel="Time to progression"
						 name="TTP"
  ;
  scatter x=OS0 y=order / markerattrs=(symbol=CircleFilled size=5 color=red)
						  legendlabel="Died"
						  name="OS"
  ;
  scatter x=TTR y=order / markerattrs=(symbol=DiamondFilled size=5 color=green)
						  legendlabel="Time to response"
						  name="TTR"
  ;
  scatter x=TTP0 y=order / markerattrs=(symbol=TriangleRightFilled size=5 color=blue)
						   legendlabel="Alive with response"
						   name="TTP0"
  ;
  yaxis display=(noticks novalues)
        min=0
		label='Individual Patients'
		offsetmin=0 offsetmax=0.02
  ;
  xaxis grid label='Months'
        offsetmin=0 offsetmax=0
		values=(0 to 20 by 2)
  ;
  keylegend "TTP" "TTR" "OS" "TTP0" / noborder
                                      location=inside
                                      position=bottomright
								      down=4
									  across=1
  ;
run;
ods graphics off;
ods html close;

*======================================================================*;
* SGPLOTvVWŏdˍ킹邱ƂłȂXe[gg̑gݍ킹 ;
*======================================================================*;
/*
ods html;
ods graphics / reset noborder noscale
               width=600px height=400px
               imagefmt=png
;
proc sgplot data=TimeToEvent00 noautolegend nocycleattrs;
  hbar order / response=TTP barwidth=0.95
			   name='TTP'
  ;
  scatter x=OS0 y=order / markerattrs=(symbol=CircleFilled size=5 color=red)
						  legendlabel="Died"
						  name="OS"
  ;
  scatter x=TTR y=order / markerattrs=(symbol=DiamondFilled size=5 color=green)
						  legendlabel="Time to response"
						  name="TTR"
  ;
  scatter x=TTP0 y=order / markerattrs=(symbol=TriangleRightFilled size=5 color=blue)
						   legendlabel="Alive with response"
						   name="TTP0"
  ;
  yaxis display=(noticks novalues)
        min=0
		label='Individual Patients'
		offsetmin=0 offsetmax=0.02
  ;
  xaxis grid label='Months'
        offsetmin=0 offsetmax=0
		values=(0 to 20 by 2)
  ;
  keylegend "TTP" "TTR" "OS" "TTP0" / noborder
                                      location=inside
                                      position=bottomright
								      down=4
									  across=1
  ;
run;
ods graphics off;
ods html close;
*/
*==================================================*;
* END ;
*==================================================*;
